package simplygroovy.bean

import org.apache.commons.beanutils.ConvertUtils
import org.apache.commons.beanutils.BeanUtils

import org.apache.commons.beanutils.converters.DateConverter

import org.joda.time.DateTime
import org.joda.time.format.DateTimeFormat
import org.joda.time.format.DateTimeFormatter

/**
 * Created: Mar 16, 2011
 * @author david
 */
class MapToBean {
    public void setJodaDateTimeFormat(String format) {
        DateTimeFormatter formatter = DateTimeFormat.forPattern(format)
        DateTimeConverter dateConverter = new DateTimeConverter(formatter)
        org.apache.commons.beanutils.ConvertUtils.register(dateConverter, DateTime.class);
    }

    public void setDateFormat(String format) {
        org.apache.commons.beanutils.converters.DateConverter dateConverter = new org.apache.commons.beanutils.converters.DateConverter();
        dateConverter.setPattern(format);
        org.apache.commons.beanutils.ConvertUtils.register(dateConverter, Date.class);
    }

    public Object convert(Class beanType, Map properties) {
        Map filtered = properties.findAll { it.value != null}
        Object bean = beanType.newInstance()
        org.apache.commons.beanutils.BeanUtils.populate(bean, filtered)
        return bean
    }
}
